<template>
  <div v-show="showWizard">
    <div class="card">
      <div class="card-header">
        <h3 class="card-title">Import statements with transactions</h3>
      </div>
      <form-wizard id="transactionsWizard" color="rgb(46, 160, 46)" @on-complete="onComplete">
        <hr/>
        <tab-content
          title="Select file"
          icon="fa fa-file"
          :before-change="beforeFileSelectTabSwitch"
        >
          <div class="card">
            <div class="card-header">
              <h3 class="card-title">All statements</h3>&nbsp;
              <i @click="getAllUserStatements()" class="fa fa-sync"></i>
            </div>
            <div class="card-body table-responsive p-0">
              <table v-if="statements.data" class="table table-hover table-striped">
                <tbody>
                  <tr>
                    <th>Name</th>
                    <th>Imported at</th>
                    <th>Not processed / all transactions</th>

                    <th>Select for transactions processing</th>
                    <th>Delete processed transactions</th>
                    <th>Delete not processed transactions</th>
                    <th>Delete transactions and statement</th>
                  </tr>
                  <tr v-for="statement in statements.data" :key="statement.id">
                    <td>{{ statement.name}}</td>
                    <td>{{ statement.created_at }}</td>
                    <td>{{ statement.not_processed_tr_count }} / {{ statement.not_processed_tr_count + statement.processed_tr_count }}</td>
                    <td
                      :class="{ selected_statement : selected_statement && statement.id == selected_statement.id}"
                    >
                      <p v-if="selected_statement && statement.id == selected_statement.id">Selected</p>
                      <a
                        v-else-if="statement.not_processed_tr_count > 0"
                        @click="selected_statement = statement"
                      >
                        <i class="fa fa-upload blue"></i>
                      </a>
                      <p v-else>-</p>
                    </td>
                    <td>
                      <a
                        v-if="statement.processed_tr_count"
                        @click="deleteTransactions(statement.id,1)"
                      >
                        <i class="fa fa-trash red"></i>
                      </a>
                      <p v-else>-</p>
                    </td>
                      <td>
                      <a
                        v-if="statement.not_processed_tr_count > 0"
                        @click="deleteTransactions(statement.id,0)"
                      >
                        <i class="fa fa-trash red"></i>
                      </a>
                      <p v-else>-</p>
                    </td>
                    <td>
                      <a     
                        @click="deleteTransactions(statement.id,2)"
                      >
                        <i class="fa fa-trash red"></i>
                      </a>
                    </td>
                  </tr>
                </tbody>
              </table>
              <hr />
              <div class="card-body-footer">
                <input class="input" @change="previewFiles" type="file" ref="file" name="file" />
                <button class="btn btn-success" @click="importStatement">
                  Import statement &nbsp;
                  <i class="fas fa-upload"></i>
                </button>
                <div v-if="selected_statement">
                  <br />
                  <br />
                  <h3>
                    Selected statement name
                    <span>{{ selected_statement.name }}</span>
                  </h3>
                </div>
              </div>
            </div>
            <div ref="importTrList" class="card-footer">
              <pagination :data="statements" @pagination-change-page="getStatResults"></pagination>
            </div>
          </div>
        </tab-content>

        <tab-content
          @on-tab-changed="beforeTransactionsProcessTabSwitch"
          title="Process transactions"
          icon="fa fa-credit-card"
        >
          <div class="card">
            <div class="card-header">
              <h3 class="card-title">Imported and not Processed Transactions</h3>
              <br />
              <p>
                You can process transaction by pressing
                <span>
                  <i class="fa fa-edit blue"></i>
                </span> and submiting updated transaction information. In component suggestion column, we will suggest you the most often used category for beneficiary. Unfortunately, if beneficiary has not yet been linked with any category, you will see "suggestion not found". If that suggested category correct, you can fast create transaction by pressing
                <span>
                  <i class="fas fa-check-circle green"></i>
                </span>. Only processed transactions will be used for computing all kinds of statistics and reports.
              </p>
            </div>
            <div class="card-body table-responsive p-0">
              <table class="table table-hover table-striped">
                <tbody>
                  <tr>
                    <th>Beneficiary</th>
                    <th>Amount, €</th>
                    <th>Date</th>
                    <th>Component suggestion</th>
                    <th>Actions</th>
                  </tr>
                  <tr v-for="transaction in transactions.data" :key="transaction.id">
                    <td>{{ transaction.custom_beneficiary.name}}</td>
                    <td>{{ transaction.totalAmount }} €</td>
                    <td>{{ transaction.date }}</td>
                    <td>
                      <p
                        v-if="transaction.mainSuggestionCategory"
                      >{{transaction.mainSuggestionCategory }} {{ transaction.totalAmount}} €</p>
                      <p v-else>-</p>
                    </td>
                    <td>
                      <a @click="editModal(transaction)">
                        <i class="fa fa-edit blue"></i>
                      </a>

                      <a @click="deleteTransaction(transaction.id)">
                        <i class="fa fa-trash red"></i>
                      </a>

                      <a
                        v-if="transaction.foundSuggestion"
                        @click="createTransaction(transaction, true)"
                      >
                        <i class="fas fa-check-circle green"></i>
                      </a>
                    </td>
                  </tr>
                </tbody>
              </table>
              <div v-if="transactionsWithSugg.length > 0" class="card-body-footer">
                <hr />
                <button class="btn btn-success" type="button" @click="saveAllTransactionsWithSuggestions">
                  Accept all
                  <i class="fas fa-plus"></i>
                </button>
              </div>
            </div>
            <div ref="importTrList" class="card-footer">
              <pagination :data="transactions" @pagination-change-page="getResults"></pagination>
            </div>
          </div>
        </tab-content>
      </form-wizard>
    </div>
    <!-- Modal -->
    <div
      class="modal fade"
      id="addNewFromStatement"
      tabindex="-1"
      role="dialog"
      aria-labelledby="addNewLabel"
      aria-hidden="true"
    >
      <div class="modal-dialog modal-dialog-centered" role="document">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="addNewLabel">Create transaction with components</h5>
            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
              <span aria-hidden="true">&times;</span>
            </button>
          </div>
          <form @submit.prevent="createTransaction(null, false)">
            <div class="modal-body">
              <div class="form-group">
                <label for="beneficiary">Beneficiary</label>
                <input
                  id="beneficiary"
                  v-model="form.beneficiary"
                  type="text"
                  name="beneficiary"
                  placeholder="Beneficiary"
                  class="form-control"
                  :class="{ 'is-invalid': form.errors.has('beneficiary') }"
                />
                <div class="help-block invalid-feedback">The beneficiary field is required.</div>
                <div v-if="form.suggestedBeneficiaryName">
                  Suggested beneficiary names:
                  <br />
                  <p class="suggested-p" @click="form.beneficiary = form.suggestedBeneficiaryName">{{ form.suggestedBeneficiaryName }}</p>
                </div>
              </div>

              <div class="form-group">
                <label for="date">Transaction date</label>
                <br />
                <date-picker
                  id="date"
                  class="date-picker"
                  v-model="form.date"
                  lang="en"
                  type="date"
                  format="YYYY-MM-DD"
                ></date-picker>
              </div>

              <button class="btn btn-success" type="button" @click="appendTransactionComponent">
                Add component
                <i class="fas fa-plus"></i>
              </button>
              <br />
              <br />
              <div v-for="(item,index) in form.transactionComponents" v-bind:key="index++">
                <h5>
                  {{ index }}. Component
                  <a
                    v-if="form.transactionComponents.length>1"
                    @click="deleteComponent(index-1,item.id)"
                  >
                    <i class="fa fa-trash red"></i>
                  </a>
                </h5>
                <div class="form-group">
                  <label for="amount">Amount, €</label>
                  <input
                    v-model="item.amount"
                    id="amount"
                    type="text"
                    name="amount"
                    placeholder="Amount"
                    class="form-control"
                    :class="{ 'is-invalid': checkError(index-1, 'amount') }"
                  />
                  <div
                    class="help-block invalid-feedback"
                  >The amount field is required and must be a number</div>
                </div>

                <div class="form-group">
                  <label for="category_name">Category name</label>

                  <select
                    v-if="form.categories.length == 0"
                    class="form-control"
                    v-model="item.category_id"
                    :class="{ 'is-invalid': checkError(index-1, 'category_id') }"
                  >
                    <option disabled value>Please select one</option>
                    <option
                      v-for="category in categories"
                      v-bind:value="category.id"
                      v-bind:key="category.id"
                    >{{ category.name }}&nbsp;</option>
                  </select>
                  <select
                    v-else
                    class="form-control"
                    v-model="item.category_id"
                    :class="{ 'is-invalid': checkError(index-1, 'category_id') }"
                  >
                    <option disabled value>Please select one</option>
                    <option
                      v-for="category in form.categories"
                      v-bind:value="category.id"
                      v-bind:key="category.id"
                    >
                      {{ category.name }}&nbsp;&nbsp;&nbsp;&nbsp;
                      <p class="suggestedOption" v-if="category.suggested">(suggested)</p>
                    </option>
                  </select>
                  <div class="help-block invalid-feedback">The category field is required</div>
                </div>
              </div>
              <form @submit.prevent="createCategory()">
                <h5>Create category</h5>
                <div class="form-group">
                  <label for="name">Name</label>
                  <input
                    v-model="categoryForm.name"
                    id="name"
                    type="text"
                    name="name"
                    placeholder="name"
                    class="form-control"
                    :class="{ 'is-invalid': categoryForm.errors.has('name') }"
                  />
                  <has-error :form="categoryForm" field="name"></has-error>
                </div>
                <button type="submit" class="btn btn-success">Create category</button>
              </form>
            </div>
            <div class="modal-footer">
              <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
              <button type="submit" class="btn btn-success">Create</button>
            </div>
          </form>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
<link
  rel="stylesheet"
  href="https://use.fontawesome.com/releases/v5.7.2/css/all.css"
  integrity="sha384-fnmOCqbTlWIlj8LyTjo7mOUStjsKC4pOpQbqyi7RrhN7udi9RwhKkMHpvLbHG9Sr"
  crossorigin="anonymous"
></link>;
</script>
<script>
export default {
  props: ["categories", "openWizard"],

  data: function() {
    return {
      statements: {},
      selected_statement: null,
      transactions: {},
      transactionsWithSugg: {},
      component: { id: null, category_id: "", amount: null },
      categoryForm: new Form({ name: null }),
      showWizard: false,
      file: "",
      page: 1,
      form: new Form({
        beneficiary: null,
        date: null,
        id: null,
        categories: null,
        distinctCategories: null,
        beneficiary_id: null,
        transactionComponents: [],
        suggestedBeneficiaryName: null
      })
    };
  },

  watch: {
    openWizard: function() {
      if (this.openWizard) {
        this.showWizard = true;
        this.transactions = {};
        this.file = null;
        this.selected_statement = null;
        this.getAllUserStatements();
      }
    }
  },

  methods: {
    beforeTransactionsProcessTabSwitch() {
      this.selected_statement = null;
      this.getAllUserStatements();
    },
    checkSuggestions(transactions) {
      return transactions.mainSuggestionCategory != null;
    },

    convertToAray(transactions) {
      return Object.keys(transactions.data).map(key => {
        return transactions.data[key];
      });
    },

    saveAllTransactionsWithSuggestions() {
      this.$Progress.start();

      axios
        .post("api/transactions", this.transactionsWithSugg)
        .then(() => {
          Fire.$emit("RefreshTransactions");
          this.getResults(this.page);

          toast({
            type: "success",
            title: "Transactions Created in successfully"
          });
          this.$Progress.finish();
        })
         .catch(error => {
          swal("Failed!", "There was something wrong.", "warning");
          this.$Progress.fail();
          console.log(error);
        });
    },
    getAllUserStatements() {
      this.$Progress.start();
      axios
        .get("api/statements")
        .then(response => {
          this.statements = response.data;
          var element = document.getElementById("transactionsWizard");
          element.scrollIntoView({ behavior: "smooth" });
          this.$Progress.finish();
        })
          .catch(error => {
          swal("Failed!", "There was something wrong.", "warning");
          this.$Progress.fail();
          console.log(error);
        });
    },
    onComplete() {
      this.showWizard = false;
      toast({
        type: "success",
        title: "Great job!"
      });
    },

    beforeFileSelectTabSwitch() {
      if (this.selected_statement) {
        this.loadImportedTransactions();
        return true;
      } else {
        swal("Failed!", "You must select file before next step", "warning");
        return false;
      }
    },

    createCategory() {
      this.$Progress.start();

      this.categoryForm
        .post("api/component-category")
        .then(() => {
          toast({
            type: "success",
            title: "Category Created in successfully"
          });
          Fire.$emit("GetCategories");
          this.$Progress.finish();
          this.categoryForm.reset();
        })
           .catch(error => {
          swal("Failed!", "There was something wrong.", "warning");
          this.$Progress.fail();
          console.log(error);
        });
    },

    deleteComponent(f_id, b_id, transactionComponent) {
      this.form.transactionComponents.splice(f_id, 1);
    },

    checkError(index, label) {
      let line = "transactionComponents." + index + "." + label;
      if (this.form.errors.has(line)) {
        return true;
      }

      return false;
    },

    appendTransactionComponent() {
      this.form.transactionComponents.push({
        id: null,
        beneficiary: null,
        category_id: "",
        amount: null,
        date: null
      });
    },

    getStatResults(page = 1) {
      this.stPage = page;
      let url = "api/statements";
      axios
        .get(url, {
          params: {
            page: page
          }
        })
        .then(response => {
          this.statements = response.data;
        }).catch(error => {
          swal("Failed!", "There was something wrong.", "warning");
          this.$Progress.fail();
          console.log(error);
        });
    },

    getResults(page = 1) {
      this.page = page;
      let url = "api/imported-transactions/" + this.selected_statement.id;

      axios
        .get(url, {
          params: {
            page: page
          }
        })
        .then(response => {
          this.transactions = response.data;
          let transactions = this.convertToAray(this.transactions);
          this.transactionsWithSugg = transactions.filter(
            this.checkSuggestions
          );
        }).catch(error => {
          swal("Failed!", "There was something wrong.", "warning");
          this.$Progress.fail();
          console.log(error);
        });
    },

    loadImportedTransactions() {
      this.$Progress.start();
      let url = "api/imported-transactions/" + this.selected_statement.id;

      axios
        .get(url)
        .then(response => {
          this.transactions = response.data;
          let transactions = this.convertToAray(this.transactions);
          this.transactionsWithSugg = transactions.filter(
            this.checkSuggestions
          );
          this.$Progress.finish();
        }).catch(error => {
          swal("Failed!", "There was something wrong.", "warning");
          this.$Progress.fail();
          console.log(error);
        });
    },

    deleteTransactions(id, processed) {
      swal({
        title: "Are you sure?",
        text: "You won't be able to revert this!",
        type: "warning",
        showCancelButton: true,
        confirmButtonColor: "#3085d6",
        cancelButtonColor: "#d33",
        confirmButtonText: "Yes, delete it!"
      }).then(result => {
        this.$Progress.start();
        if (result.value) {
          axios
            .delete("api/statements/" + id + "/" + processed)
            .then(() => {
              swal(
                "Deleted!",
                "Transactions Deleted in successfully.",
                "success"
              );
              this.getAllUserStatements();
              Fire.$emit("RefreshTransactions");
              this.$Progress.finish();
            })
           .catch(error => {
          swal("Failed!", "There was something wrong.", "warning");
          this.$Progress.fail();
          console.log(error);
        });
        }
      });
    },

    deleteTransaction(id) {
      swal({
        title: "Are you sure?",
        text: "You won't be able to revert this!",
        type: "warning",
        showCancelButton: true,
        confirmButtonColor: "#3085d6",
        cancelButtonColor: "#d33",
        confirmButtonText: "Yes, delete it!"
      }).then(result => {
        if (result.value) {
                this.$Progress.start();
          this.form
            .delete("api/transaction/" + id)
            .then(() => {
              swal("Deleted!", "Your transaction has been Deleted.", "success");
              this.getResults(this.page);
              this.$Progress.finish();
            })
            .catch(error => {
              swal("Failed!", "There was something wrong", "warning");
              this.$Progress.fail();
              console.log(error);
            });
        }
      });
    },

    previewFiles(event) {
      this.file = event.target.files[0];
    },

    resetComponent() {
      this.component.amount = null;
      this.component.category_id = "";
      this.component.id = null;
    },

    openFileImportModal() {
      $("#fileImport").modal("show");
    },

    editModal(transaction) {
      this.form.reset();
      this.form.fill(transaction);
      this.form.beneficiary = transaction.custom_beneficiary.name;
      this.form.beneficiary_id = transaction.custom_beneficiary.id;
      this.form.transactionComponents = [];
      this.form.errors.errors = [];

      transaction.transactionComponents.forEach(this.setComponentsData);

      this.resetComponent();

      this.form.date = new Date(transaction.date);
      $("#addNewFromStatement").modal("show");
    },

    setComponentsData(item, index) {
      this.component.id = item.id;
      this.component.category_id = item.category_id;
      this.component.amount = item.amount;

      this.form.transactionComponents.push({ ...this.component });
    },

    createTransaction(transaction, createWithoutModal) {
      if (createWithoutModal) {
        this.form.fill(transaction);
        this.form.beneficiary_id = transaction.custom_beneficiary.id;
        this.form.beneficiary = transaction.custom_beneficiary.name;
      }

      this.$Progress.start();
      this.form
        .post("api/transaction")
        .then(() => {
            $("#addNewFromStatement").modal("hide");

            Fire.$emit("RefreshTransactions");
            this.getResults(this.id);
            toast({
              type: "success",
              title: "Transaction Created in successfully"
            });
            this.$Progress.finish();
        })
          .catch(error => {
          swal("Failed!", "There was something wrong.", "warning");
          this.$Progress.fail();
          console.log(error);
        });
    },

    importStatement: function() {
      $("#category").prop("selectedIndex", 0); // reset selector
      this.$Progress.start();
      if (!this.file) {
        this.$Progress.fail();
        swal({
          type: "error",
          title: "Oops...",
          text: "File was not selected"
        });
      } else if (
        this.file["type"] != "text/csv" &&
        this.file["type"] != "application/vnd.ms-excel"
      ) {
        this.$Progress.fail();
        swal({
          type: "error",
          title: "Oops...",
          text: "File is in wrong format"
        });
      } else if (this.file["size"] >= 1024 * 1024 * 2) {
        this.$Progress.fail();
        swal({
          type: "error",
          title: "Oops...",
          text: "You are uploading too big file"
        });
      } else {
        let formData = new FormData();

        formData.append("file", this.file);
        axios
          .post("/api/statement/import", formData, {
            headers: {
              "Content-Type": "multipart/form-data"
            }
          })
          .then(response => {
            this.getAllUserStatements();
            toast({
              type: "success",
              title: "File uploaded in successfully"
            });
            this.$Progress.finish();
          })
          .catch(error => {
            swal(
              "Failed!",
              "There was something wrong. Please check if fields beneficiary, date, amount, dk are filled correctly",
              "warning"
            );
            this.$Progress.fail();
            console.log(error);
          });
      }
    }
  }
};
</script>

